﻿using Newtonsoft.Json;
using StockInQuiry.Dto;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace StockInQuiry
{
    public partial class BomCostInquiryForm : Form
    {
        public BomCostInquiryForm(string materialCode,string environment)
        {
            InitializeComponent();

            string url = environment + "api/stockInquiry/getBomPriceInquiry/" + materialCode;
            if (!string.IsNullOrEmpty(materialCode))
            {
                GetBomPriceInformation(url);
            }
        }

        private async void GetBomPriceInformation(string url)
        {
            using (HttpClient client = new HttpClient())
            {
                try
                {
                    HttpResponseMessage response = await client.GetAsync(url);
                    response.EnsureSuccessStatusCode();

                    string content = await response.Content.ReadAsStringAsync();
                    BomPriceInquiryOutput result = JsonConvert.DeserializeObject<BomPriceInquiryOutput>(content);
                    var data = result.result;
                    for (var i = 0; i < data.Count; i++)
                    {
                        int index = dataGridView1.Rows.Add();
                        dataGridView1.Rows[index].Cells["物料编码"].Value = data[i].materialCode;
                        dataGridView1.Rows[index].Cells["物料名称"].Value = data[i].materialName;
                        dataGridView1.Rows[index].Cells["价格"].Value = data[i].Verpr;
                        if (data[i].DateUpdated != DateTime.MinValue)
                        {
                            dataGridView1.Rows[index].Cells["更新日期"].Value = data[i].DateUpdated;
                        }
                        dataGridView1.Rows[index].Cells["状态"].Value = data[i].State;
                    }
                    InExecutionlabel.Text = "";
                }

                catch (HttpRequestException e)
                {
                    MessageBox.Show($"Request failed: {e.Message}");
                }
            }
        }
    }
}
