﻿using Newtonsoft.Json;
using StockInQuiry.Dto;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.AxHost;

namespace StockInQuiry
{
    public partial class BomstockInquiryForm : Form
    {
        public BomstockInquiryForm(string materialCode,string environment)
        {
            InitializeComponent();

            string url = environment + "api/stockInquiry/getBomProductInventory/" + materialCode;
            if (!string.IsNullOrEmpty(materialCode))
            {
                FetchProductInventory(url);
            }
        }
        private async void FetchProductInventory(string url)
        {
            using (HttpClient client = new HttpClient())
            {
                try
                {
                    HttpResponseMessage response = await client.GetAsync(url);
                    response.EnsureSuccessStatusCode();

                    string content = await response.Content.ReadAsStringAsync();
                    BomStockInquiryOutput result = JsonConvert.DeserializeObject <BomStockInquiryOutput>(content);
                    var data = result.result;
                    for (var i = 0; i < data.Count; i++)
                    {
                        int index = dataGridView1.Rows.Add();
                        dataGridView1.Rows[index].Cells["物料编码"].Value = data[i].materialCode;
                        dataGridView1.Rows[index].Cells["物料名称"].Value = data[i].materialName;
                        dataGridView1.Rows[index].Cells["库存"].Value = data[i].Labst;
                        dataGridView1.Rows[index].Cells["预留"].Value = data[i].Bdmng;
                        dataGridView1.Rows[index].Cells["未清采购申请数量"].Value = data[i].ZwqslPr;
                        dataGridView1.Rows[index].Cells["未清采购订单数量"].Value = data[i].ZwqslPo;
                        if (data[i].DateUpdated != DateTime.MinValue)
                        {
                            dataGridView1.Rows[index].Cells["更新日期"].Value = data[i].DateUpdated;
                        }
                        dataGridView1.Rows[index].Cells["状态"].Value = data[i].State;
                    }
                    InExecutionlabel.Text = "";
                }
                
                catch (HttpRequestException e)
                {
                    MessageBox.Show($"Request failed: {e.Message}");
                }
            }
        }

        
    }
}
