﻿using EPDM.Interop.epdm;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace StockInQuiry
{
    [ComVisible(true)]
    [Guid("2e434738-8e71-43e7-a580-cb464a021b30")]
    public class PdmAddIn : IEdmAddIn5
    {
        //切换环境
        //private string environment = "http://192.168.10.101:5005/";
        //private string environment = "http://192.168.10.74:5005/";
        private string environment = "http://localhost:5005/";

        const int TEST_CMD_ID = 1;
        public void GetAddInInfo(ref EdmAddInInfo poInfo, IEdmVault5 poVault, IEdmCmdMgr5 poCmdMgr)
        {
            poInfo.mbsAddInName = "SAP库存查询";
            poInfo.mbsCompany = "智鹰数字科技";
            poInfo.mbsDescription = "用于查询SAP系统实时库存";
            poInfo.mlRequiredVersionMajor = 24;
            poCmdMgr.AddHook(EdmCmdType.EdmCmd_CardButton);

        }

        public void OnCmd(ref EdmCmd poCmd, ref EdmCmdData[] ppoData)
        {

            string CommandName = null;
            if (poCmd.mlCmdID == 1000)
            {
                CommandName = "第一个命令。";
            }
            else
            {
                CommandName = poCmd.mbsComment;  //获取当前按钮名称
            }
            try
            {
                if (CommandName.StartsWith("SAP库存查询"))
                {
                    var edmCard = poCmd.mpoExtra;
                    // 获取变量"名称"的值
                    IEdmEnumeratorVariable8 variableEnumerator = (IEdmEnumeratorVariable8)edmCard;
                    variableEnumerator.GetVar("SW-物料编码", "", out object materialCode);//SW-物料编码

                    // 创建Form1的实例并传递变量值

                    StockInQuiryForm form1 = new StockInQuiryForm(materialCode?.ToString(), environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("BOM库存查询"))
                {
                    var edmCard = poCmd.mpoExtra;
                    // 获取变量"名称"的值
                    IEdmEnumeratorVariable8 variableEnumerator = (IEdmEnumeratorVariable8)edmCard;
                    variableEnumerator.GetVar("SW-物料编码", "", out object materialCode);

                    // 创建Form1的实例并传递变量值

                    BomstockInquiryForm form1 = new BomstockInquiryForm(materialCode?.ToString(), environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("原材料库存查询"))
                {

                    RawMaterialForm form1 = new RawMaterialForm(environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("SAP价格查询"))
                {
                    var edmCard = poCmd.mpoExtra;
                    // 获取变量"名称"的值
                    IEdmEnumeratorVariable8 variableEnumerator = (IEdmEnumeratorVariable8)edmCard;
                    variableEnumerator.GetVar("SW-物料编码", "", out object materialCode);
                    PriceInquiryForm form1 = new PriceInquiryForm(materialCode?.ToString(), environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("BOM价格查询"))
                {
                    var edmCard = poCmd.mpoExtra;
                    // 获取变量"名称"的值
                    IEdmEnumeratorVariable8 variableEnumerator = (IEdmEnumeratorVariable8)edmCard;
                    variableEnumerator.GetVar("SW-物料编码", "", out object materialCode);

                    // 创建Form1的实例并传递变量值

                    BomCostInquiryForm form1 = new BomCostInquiryForm(materialCode?.ToString(), environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("原材料价格查询"))
                {
                    RawMaterialPriceInquiryForm form1 = new RawMaterialPriceInquiryForm(environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("产品设计库库存查询"))
                {
                    PdmStockInquiryForm form1 = new PdmStockInquiryForm(environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("产品设计库价格查询"))
                {
                    PdmCostInquiryForm form1 = new PdmCostInquiryForm(environment);
                    form1.ShowDialog();
                    return;
                }

                if (CommandName.StartsWith("BOM差异对比"))
                {
                    var edmCard = poCmd.mpoExtra;
                    // 获取变量"名称"的值
                    IEdmEnumeratorVariable8 variableEnumerator = (IEdmEnumeratorVariable8)edmCard;
                    variableEnumerator.GetVar("SW-物料编码", "", out object materialCode);
                    BomComparisonForm form1 = new BomComparisonForm(materialCode?.ToString(), environment);
                    form1.ShowDialog();
                    return;
                }
            }
            catch (Exception ex)
            {

                MessageBox.Show(ex.ToString());
                return;
            }
        }
    }
}
