﻿using Newtonsoft.Json;
using StockInQuiry.Dto;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using static System.Windows.Forms.AxHost;

namespace StockInQuiry
{
    public partial class PriceInquiryForm : Form
    {
        public PriceInquiryForm(string materialCode, string environment)
        {
            InitializeComponent();
            code.Text = materialCode;
            if (string.IsNullOrEmpty(materialCode))
            {
                state.Text = "查询失败";
            }

            string url = environment + "api/stockInquiry/getPriceInquiry/" + materialCode;
            if (!string.IsNullOrEmpty(materialCode))
            {
                GetPriceInformation(url);
            }
        }

        private async void GetPriceInformation(string url)
        {
            using (HttpClient client = new HttpClient())
            {
                try
                {
                    HttpResponseMessage response = await client.GetAsync(url);
                    response.EnsureSuccessStatusCode();
                    string content = await response.Content.ReadAsStringAsync();
                    SapPriceInquiryOutput result = JsonConvert.DeserializeObject<SapPriceInquiryOutput>(content);
                    if (result.result.Code == "S")
                    {
                        state.Text = "查询成功";
                        price.Text = result.result.Verpr;
                        inventoryDate.Text = result.result.DateUpdated.ToString("yyyy-MM-dd HH:dd:ss");
                    }
                    else
                    {
                        state.Text = "查询失败";
                    }
                }
                catch (HttpRequestException e)
                {

                    MessageBox.Show($"Request failed: {e.Message}");
                }
            }
        }
    }
}
