﻿using Newtonsoft.Json;
using StockInQuiry.Dto;
using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace StockInQuiry
{
    public partial class StockInQuiryForm : Form
    {
        public StockInQuiryForm(string materialCode, string environment)
        {
            InitializeComponent();
            code.Text = materialCode;
            if (string.IsNullOrEmpty(materialCode))
            {
                state.Text = "查询失败";
            }

            string url = environment + "api/stockInquiry/getProductInventory/" + materialCode;
            if (!string.IsNullOrEmpty(materialCode))
            {
                FetchProductInventory(url);
            }


        }

        private async void FetchProductInventory(string url)
        {
            using (HttpClient client = new HttpClient())
            {
                try
                {
                    HttpResponseMessage response = await client.GetAsync(url);
                    response.EnsureSuccessStatusCode();

                    string content = await response.Content.ReadAsStringAsync();
                    SapEcnQueryOutput result = JsonConvert.DeserializeObject<SapEcnQueryOutput>(content);

                    if (result.result.Code == "S")
                    {
                        stock.Text = result.result.Labst;
                        reserved.Text = result.result.Bdmng;
                        applyForQuantity.Text = result.result.ZwqslPr;
                        orderForGoodsQuantity.Text = result.result.ZwqslPo;
                        inventoryDate.Text = result.result.DateUpdated.ToString("yyyy-MM-dd HH:dd:ss");
                        state.Text = "查询成功";
                    }
                    else
                    {
                        state.Text = "SAP未查询到库存信息";
                    }

                }
                catch (HttpRequestException e)
                {
                    MessageBox.Show($"Request failed: {e.Message}");
                }
            }
        }
    }
}
